package com.galaxis.manatee.controller;

import com.galaxis.manatee.dao.ChuanyunUserDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunUserDO;
import com.galaxis.manatee.util.ExcelUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.List;

@RestController
@Slf4j
public class ExcelController {

    private final ChuanyunUserDao chuanyunUserDao;

    public ExcelController(ChuanyunUserDao chuanyunUserDao) {
        this.chuanyunUserDao = chuanyunUserDao;
    }


    @ResponseBody
    @RequestMapping(value = "/test/exportExcel", method = RequestMethod.GET)
    public void exportExcel(HttpServletRequest request, HttpServletResponse response) throws Exception {
        List<ChuanyunUserDO> list = chuanyunUserDao.findAll();
        String[] title = {"ID", "姓名", "头像", "工号", "钉钉号"};
        String filename = "testRecord.xls";
        String sheetName = "sheet1";
        String[][] content = new String[list.size()][7];
        try {
            for (int i = 0; i < list.size(); i++) {
                content[i][0] = String.valueOf(list.get(i).getObjectId());
                content[i][1] = list.get(i).getName();
                content[i][2] = list.get(i).getPhoto();
                content[i][3] = list.get(i).getEmployeeNumber();
                content[i][4] = list.get(i).getDingTalkAccount();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        HSSFWorkbook wb = ExcelUtils.getHSSFWorkbook(sheetName, title, content, null);
        try {
            // 响应到客户端
            this.setResponseHeader(response, filename);
            OutputStream os = response.getOutputStream();
            wb.write(os);
            os.flush();
            os.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 向客户端发送响应流方法
     *
     * @param response
     * @param fileName
     */
    public void setResponseHeader(HttpServletResponse response, String fileName) {
        try {
            try {
                fileName = new String(fileName.getBytes(), "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            response.setContentType("application/vnd.ms-excel");
            response.setHeader("Content-disposition", "attachment;filename=" + URLEncoder.encode(fileName, "UTF-8"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
